"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
const comments_1 = require("../utils/comments");
const multiLineCommentRegex = /\/\*(?:[\s\S]*?)\*\//gim;
const parserFactory = ({ customTags }) => {
    const regex = utils_1.getRegex(customTags);
    const lineCommentRegex = new RegExp(`^\\s*\\/\\/${regex}$`, 'ig');
    const innerBlockRegex = new RegExp(`^\\s*(?:\\/\\*)?\\**!?${regex}(?:\\**\\/)?$`, 'ig');
    return (contents, file) => {
        const singleLineComments = comments_1.extractSingleLineComments(contents, file, lineCommentRegex);
        const singleLineMultiBlockComments = comments_1.extractSingleLineFromBlocks(contents, file, multiLineCommentRegex, innerBlockRegex);
        return singleLineComments.concat(singleLineMultiBlockComments);
    };
};
exports.default = parserFactory;
