"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getLineFromPos = exports.getRegex = exports.prepareComment = void 0;
const eol_1 = require("eol");
var comments_1 = require("./comments");
Object.defineProperty(exports, "prepareComment", { enumerable: true, get: function () { return comments_1.prepareComment; } });
Object.defineProperty(exports, "getRegex", { enumerable: true, get: function () { return comments_1.getRegex; } });
// Bases on get-line-from-pos to support Windows as well
// See https://github.com/pgilad/get-line-from-pos/blob/master/index.js
const getLineFromPos = (str, pos) => {
    if (pos === 0) {
        return 1;
    }
    //adjust for negative pos
    if (pos < 0) {
        pos = str.length + pos;
    }
    const lines = eol_1.split(str.substr(0, pos));
    return lines.length;
};
exports.getLineFromPos = getLineFromPos;
